package cn.yw.video.videotask.action;

 import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.cxf.common.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.DateUtil;
import cn.base.util.LogConstants;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.bsystem.ptuserrole.model.PtyhBean;
import cn.yw.video.videochannelset.service.YwvideochannelsetlistService;
import cn.yw.video.videotask.service.YwvideotaskbysetlistService;

@SuppressWarnings({"all"})
@Component("ywvideotaskbysetlistAction")
public class YwvideotaskbysetlistAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(YwvideotaskbysetlistAction.class);
	
	@Autowired
	private YwvideotaskbysetlistService service;
	@Autowired
	private YwvideochannelsetlistService channelsetlistService;
	/**
	 * 分页
	 */
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="listYwvideotaskbysetlistByPage")
	public void listYwvideotaskbysetlistByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listYwvideotaskbysetlistByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-listYwvideotaskbysetlistByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	public void listYwvideotaskbysetlistByPage_task(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listYwvideotaskbysetlistByPage_task(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-listYwvideotaskbysetlistByPage_task-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询总数
	 */
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Ywvideotaskbysetlist")
	public void count_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Ywvideotaskbysetlist(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-count_Ywvideotaskbysetlist-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 Ywvideotaskbysetlist
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Ywvideotaskbysetlist")
	public void query_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Ywvideotaskbysetlist(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-query_Ywvideotaskbysetlist-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 一条Ywvideotaskbysetlist
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Ywvideotaskbysetlist")
	public void get_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Ywvideotaskbysetlist(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistActionquery_Ywvideotaskbysetlist-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="delete_Ywvideotaskbysetlist")
	public void delete_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String taskid = (String) map.get("taskid");
			String channelsetid = (String) map.get("LIKEchannelsetid");
			if(StringUtils.isEmpty(taskid) || StringUtils.isEmpty(channelsetid)){
				Struts2Utils.renderJson(null);
				return ;
			}
			service.delete_Ywvideotaskbysetlist(map);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-delete_Ywvideotaskbysetlist-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}

	/**
	 * 插入
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Ywvideotaskbysetlist")
	public void insert_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("id"))){
				map.put("id",StringUtil.getUUID());
			}
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywvideotaskbysetlist(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					service.insert_Ywvideotaskbysetlist(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				service.insert_Ywvideotaskbysetlist(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-insert_Ywvideotaskbysetlist()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	/**
	 * 选择集合
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="batch_insert_Ywvideotaskbysetlist")
	public void batch_insert_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String taskid = (String) map.get("taskid");
			String channelsetid = (String) map.get("LIKEchannelsetid");
			if(StringUtils.isEmpty(taskid) || StringUtils.isEmpty(channelsetid)){
				Struts2Utils.renderJson(null);
				return ;
			}
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhzh();
			String nowTime = DateUtil.currentDateTime();
			List<Map> channelsetList = channelsetlistService.query_Ywvideochannelsetlist(map);
			if(channelsetList!=null && channelsetList.size()>0){
				List<Map> insertList = new ArrayList<Map>();
				for(int i=0;i<channelsetList.size();i++){
					Map m = channelsetList.get(i);
					m.put("id",StringUtil.getUUID());
					m.put("taskid",taskid);
					m.put("createaccount", username);
					m.put("modifyaccount", username);
					m.put("createtime", nowTime);
					m.put("modifytime", nowTime);
					m.put("remarks", "");
					m.put("extend1", "");
					m.put("extend2", "");
					m.put("extend3", "");
					m.put("extend4", "");
					insertList.add(m);
				}
				if(insertList!=null && insertList.size()>0){
					service.batch_insert_Ywvideotaskbysetlist(insertList);
				}
			}
			
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-insert_Ywvideotaskbysetlist_task()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Ywvideotaskbysetlist")
	public void update_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywvideotaskbysetlist(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					int result = service.update_Ywvideotaskbysetlist(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				int result = service.update_Ywvideotaskbysetlist(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-update_Ywvideotaskbysetlist-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 批量删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Ywvideotaskbysetlist")
	public void batch_delete_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Ywvideotaskbysetlist(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-batch_delete_Ywvideotaskbysetlist-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	/**
	 * 批量修改检测开关
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_update_Ywvideotaskbysetlist")
	public void batch_update_Ywvideotaskbysetlist(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			String keyword = map.get("keyword").toString();
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhzh();
			m.put("modifyaccount", username);
			m.put("modifytime", DateUtil.currentDateTime());
			m.put("detectionswitch", map.get("detectionswitch"));
			if(StringUtil.isEmpty(keyword)){
				Struts2Utils.renderJson(null);
				return ;
			}else{
				List<String> lists = new ArrayList<String>();
				String[] ids = keyword.split(",");
				for(int i=0;i<ids.length;i++){
					lists.add(ids[i]);
				}
				if(lists!=null && lists.size()>0){
					m.put("list", lists);
					service.batch_update_Ywvideotaskbysetlist(m);
				}
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-batch_update_Ywvideotaskbysetlist-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 导出Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Ywvideotaskbysetlist")
	public void exp_Ywvideotaskbysetlist(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Ywvideotaskbysetlist(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "运维监控任务关联集合列表-"+dateTime);
			params.put("sheetName", "运维监控任务关联集合列表");
			params.put("header", "运维监控任务关联集合列表");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideotaskbysetlistAction-exoprtExcel-error:" +e);
			
		}
	}
	*/
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Ywvideotaskbysetlist")
	public String imp_Ywvideotaskbysetlist(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("YwvideotaskbysetlistAction-imp_Ywvideotaskbysetlist-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
}
